library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
library UNISIM;
use UNISIM.VComponents.all;

entity compare is
    
    generic (
	   INIT1 : bit_vector(15 downto 0):="1011101110101010";
	   INIT2 : bit_vector(15 downto 0):="1011101110101010"
	 ); 
	 
	 port (
	 	a: in std_logic_vector(6 downto 0);
		clk : in std_logic;
		equal : out std_logic
		);

end compare;

architecture Behavioral of compare is

  component LUT4 
--
  generic (INIT : bit_vector(15 downto 0):="1011101110101010"); 
--
  port (
    I0 : in std_logic;
    I1 : in std_logic;
    I2 : in std_logic;
    I3 : in std_logic;
    O : out std_logic
  );
end component;

component MUXCY
  port (
    DI : in std_logic;
    CI : in std_logic;
    S : in std_logic;
    O : out std_logic
  );
end component;

----- component FD                      -----
  component FD
    generic(
      INIT : bit := '0' 
      );

    port(
      Q : out std_logic;
      C : in  std_logic;
      D : in  std_logic
      );
  end component;

  signal lut1_out, lut2_out, carry_out, carry_out_internal: std_logic;

begin

  output_ff: FD
    generic map (
      INIT => '0' 
      )

	 port map(
      Q => equal,
		C => clk,
		D => carry_out
      );

   L1 : LUT4 
  generic map (
     INIT => init1)

  port map (
    I0 => a(0),
    I1 => a(1),
    I2 => a(2),
    I3 => a(3),
    O => lut1_out
  );

 L2 : LUT4 
  generic map (
     INIT => init2)

  port map (
    I0 => a(4),
    I1 => a(5),
    I2 => a(6),
    I3 => a(6),
    O => lut2_out
  );

  m1 : MUXCY
  port map(
    DI => '0',
    CI => '1',
    S => lut1_out,
    O => carry_out_internal
  );
  
  m2 : MUXCY
  port map(
    DI => '0',
    CI => carry_out_internal,
    S => lut1_out,
    O => carry_out
  );


end Behavioral;
